<template>
  <el-card shadow="never" class="aui-card--fill">
    <div class="mod-sys__user">
      <SearchBar :formConfigs="formConfig" ref="ruleForm" @headBtnClick="buttonClick">
        <el-badge :value="1" class="item">
          <el-button type="primary" size="small" @click="conditionSearch">条件搜索</el-button>
        </el-badge>
      </SearchBar>
      <base-table id="palletTable" :table-props="tableProps" :page="listQuery.page" ref="palletTable1"
        highlight-current-row :limit="listQuery.limit" :table-data="tableData" @current-change="handleCurrentChange">
        <method-btn v-if="tableBtn.length" slot="handleBtn" :width="100" label="操作" :method-list="tableBtn"
          @clickBtn="handleClick" />
      </base-table>
      <pagination :limit.sync="listQuery.limit" :page.sync="listQuery.page" :total="listQuery.total"
        @pagination="getDataList" />
      <!-- 弹窗, 新增 / 修改 -->
      <base-dialog :dialogTitle="productOrEditTitle" :dialogVisible="productOrUpdateVisible"
        @cancel="handleProductCancel" :before-close="handleProductCancel">
        <show-product-list ref="productOrUpdate" @successSubmit="successSubmit"></show-product-list>
        <el-row slot="footer" type="flex" justify="end"> </el-row>
      </base-dialog>
      <base-dialog :dialogTitle="addOrEditTitle" :dialogVisible="addOrUpdateVisible" @cancel="handleCancel"
        @confirm="handleConfirm" :before-close="handleCancel">
        <control-add ref="addOrUpdate" @successSubmit="successSubmit"></control-add>
        <!-- <el-row slot="footer" type="flex" justify="end"> </el-row> -->
      </base-dialog>
      <base-dialog :dialogTitle="searchOrEditTitle" :dialogVisible="searchOrUpdateVisible" @cancel="handleSearchCancel"
        @confirm="handleSearchConfirm" :before-close="handleSearchCancel">
        <control-search ref="searchOrUpdate" @refreshDataList="conditionSearchSubmit"></control-search>
        <el-row slot="footer" type="flex" justify="end">
          <el-col :span="12">
            <el-button size="small" type="primary" plain class="btnTextStyle" @click="handleSearchCancel">
              {{ $t("close") }}
            </el-button>
            <el-button size="small" class="btnTextStyle" type="primary" plain @click="handleSearchReset">{{ $t("reset")
              }}</el-button>
            <el-button type="primary" size="small" class="btnTextStyle" @click="handleSearchConfirm">
              {{ $t("search") }}
            </el-button>
          </el-col>
        </el-row>
      </base-dialog>
    </div>
  </el-card>
</template>

<script>
import basicPage from "@/mixins/basic-page";
import basicSearch from "@/mixins/basic-search";
import showProductList from "./components/showProductList.vue";
import controlSearch from "./components/controlSearch.vue";
import controlAdd from "./components/control-add.vue";
import available from "./components/available.vue";
import planBtn from "./components/planBtn.vue";
import radio from "./components/radio.vue";
import i18n from "@/i18n";
// import i18n from "@/i18n";
const tableProps = [
  {
    prop: "controlCode",
    label: i18n.t('basic.code'),
  },
  {
    prop: "controlName",
    label: i18n.t('basic.name'),
  },
  {
    prop: "specifications",
    label: i18n.t('basic.specification'),
  },
  {
    prop: "detail",
    label: i18n.t('basic.InspectionStage'),
    subcomponent: radio,
  },
  {
    prop: "controlStatus",
    label: i18n.t('basic.available'),
    subcomponent: available,
  },
  {
    prop: "remark",
    label: i18n.t('schedule.remark'),
  },
  {
    prop: "valid",
    label: i18n.t('basic.InspectionPlan'),
    subcomponent: planBtn,
  },
];
const tableBtn = [
  {
    type: "edit",
    btnName: i18n.t('t.edit'),
  },
  {
    type: "delete",
    btnName: i18n.t('t.delete'),
  },
];
export default {
  mixins: [basicPage, basicSearch],
  data() {
    return {
      urlOptions: {
        getDataListURL: "/basic/qmsControlMode/page",
        deleteURL: "/basic/qmsControlMode",
      },
      tableProps,
      tableBtn,
      productData: {},
      searchOrEditTitle: "",
      searchOrUpdateVisible: false,
      productOrEditTitle: "",
      addOrEditTitle: '',
      addOrUpdateVisible:false,
      productOrUpdateVisible: false,
      formConfig: [
        // {
        //   type: "",
        //   label: i18n.t("params.paramCode"),
        //   placeholder: i18n.t("params.paramCode"),
        //   param: "paramCode",
        // },
        // {
        //   type: "separate",
        // },
        {
          type: "button",
          btnName: "新增",
          name: "add",
          color: "primary",
        },
        {
          type: "button",
          btnName: "搜索",
          name: "search",
          color: "primary",
          // plain: true,
        },
        {
          type: "button",
          btnName: "关联产品列表",
          name: "correlation",
          color: "primary",
          // plain: true,
        },
        {
          type: "button",
          btnName: "取消选中",
          name: "cancel",
          color: "primary",
          // plain: true,
        },
      ],
    };
  },
  components: {
    showProductList,
    controlSearch,
    controlAdd
  },
  methods: {
    //search-bar点击
    handleProductCancel() {
      this.productOrUpdateVisible = false;
      this.productOrEditTitle = "";
    },
    handleCurrentChange(val) {
      console.log(val);
      this.productData = val.newVal ? val.newVal: {}
    },
    setCurrent(index) {
      this.$refs.palletTable1.setCurrent("palletTable", index);
    },
    // handleSearchCancel() {
    //   this.searchOrEditTitle = "";
    //   this.searchOrUpdateVisible = false;
    // },
    conditionSearch() {
      this.searchOrEditTitle = "搜索";
      this.searchOrUpdateVisible = true;
      this.$nextTick(() => {
        this.$refs.searchOrUpdate.init();
      });
    },
    // handleConfirm() {
    //   this.$refs.addOrUpdate.dataFormSubmitHandle();
    // },
    // conditionSearchSubmit() {},
    conditionSearchSubmit(key) {
      // console.log(key);
      console.log(key);
      this.listQuery.key = key;
      this.listQuery.page = 1;
      this.getDataList(key);
      this.searchOrUpdateVisible = false;
      // console.log(11111);
      // this.conditionSearchSubmit();
    },
    handleClick(val) {
      if (val.type === "delete") {
        this.$confirm(`确定对[名称=${val.data.customerTypeName}]进行删除操作?`, "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        })
          .then(() => {
            this.$http.delete(this.urlOptions.deleteURL, { data: [val.data.id] }).then(({ data }) => {
              if (data && data.code === 0) {
                this.$message({
                  message: "操作成功",
                  type: "success",
                  duration: 1500,
                  onClose: () => {
                    this.getDataList();
                  },
                });
              } else {
                this.$message.error(data.msg);
              }
            });
          })
          .catch(() => { });
      } else if (val.type === 'edit') {
        this.addOrUpdateVisible = true 
        this.addOrEditTitle = this.$t('edit')
        this.$nextTick(() => {
          this.$refs.addOrUpdate.init(val.data.id);
        });
      }
    },
    // addOrUpdateHandle(productData) {
    //   this.addOrUpdateVisible = true;
    //   this.$nextTick(() => {
    //     this.$refs.addOrUpdate.init(productData);
    //   });
    // },
    buttonClick(val) {
      console.log(val);
      switch (val.btnName) {
        case "search":
          // this.listQuery.paramCode = val.paramCode;
          this.listQuery.key = null;
          console.log(i18n  );
          this.listQuery.page = 1;
          this.getDataList();
          break;
        case "correlation":
          this.productOrEditTitle = "产品";
          this.productOrUpdateVisible = true;
          // this.searchOrUpdateHandle(this.productData);
          // this.searchOrUpdateVisible = true;
          this.$nextTick(() => {
            this.$refs.productOrUpdate.init(this.productData);
          });
          console.log(this.productId);
          break;
        case "add":
          this.addOrEditTitle = '新增'
          this.addOrUpdateVisible = true;
          this.addOrUpdateHandle()
          break;
        case "cancel":
          this.$refs.palletTable1.setCurrent("palletTable", -1);
          break;
        default:
          console.log(val);
      }
    },
  },
};
</script>
